import 'package:domain/entity/feedback_list_entity.dart';
import 'package:widgets/load_state_layout.dart';

class FeedbackHistoryState {

  //页面 LoadView 状态的展示
  LoadState loadingState;
  String? errorMessage;

  List<FeedbackItemEntity> datas; //页面列表数据

  // ===================================  Begin  ↓  ===================================

  FeedbackHistoryState({
    this.loadingState = LoadState.State_Loading,
    this.errorMessage,
    required this.datas,
  });

  FeedbackHistoryState copyWith({
    LoadState? loadingState,
    String? errorMessage,
    bool? needShowPlaceholder,
    List<FeedbackItemEntity>? datas,
  }) {
    return FeedbackHistoryState(
      errorMessage: errorMessage ?? this.errorMessage,
      loadingState: loadingState ?? this.loadingState,
      datas: datas ?? this.datas,
    );
  }
}
